/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *               and Dresden University
 *                
 * File path:     l4ms/x86/idt.h
 * Description:   idt entry specification 
 *                (see: IA-32 architecture reference manual)
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * idt.h,v 1.2 2001/12/13 08:47:30 uhlig Exp
 *                
 ********************************************************************/

#ifndef __L4_X86_IDT_H__ 
#define __L4_X86_IDT_H__ 

#define TRAPGATE        0x70
#define USERLEVEL       0x03
#define SEGPRESENT      0x01

typedef struct { 
   unsigned IntHandlerLow:  16; 
   unsigned Selector:       16; 
   unsigned Reserved:        5; 
   unsigned TrapGate:        8; 
   unsigned Privilege:       2; 
   unsigned Present:         1; 
   unsigned IntHandlerHigh: 16;
} IDTEntryT;

typedef void (*IntHandlerT)(void);

#endif /* __L4_X86_IDT_H__ */
