/*********************************************************************
 *                
 * Copyright (C) 2001,  Karlsruhe University
 *                
 * File path:     lib/io/get_hex.c
 * Description:   generic get_hex() based on putc() and getc()
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * get_hex.c,v 1.7 2001/11/30 14:24:22 ud3 Exp
 *                
 ********************************************************************/

#include <l4/l4.h>
#include <l4io.h>

word_t
get_hex(void)
{
  word_t val = 0;
  char c, t;
  int i = 0;

  while ((t = c = getc()) != '\r')
  {
      switch(c)
      {
      case '0' ... '9':
	  c -= '0';
	  break;
	  
      case 'a' ... 'f':
	  c -= 'a' - 'A';
      case 'A' ... 'F':
	  c = c - 'A' + 10;
	  break;
      default:
	  continue;
      };
      val <<= 4;
      val += c;
      
      /* let the user see what happened */
      putc(t);

      if (++i == 8)
	  break;
  };
  return val;
}
