/*********************************************************************
 *                
 * Copyright (C) 1999, 200, 2001,  Karlsruhe University
 *                
 * File path:     arm/ep7211/cpu.h
 * Description:   CPU related declarations specific to EP7211.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * cpu.h,v 1.2 2001/11/22 14:56:36 skoglund Exp
 *                
 ********************************************************************/
#ifndef __ARM__EP7211__CPU_H__
#define __ARM__EP7211__CPU_H__

/* CP15 Flush Instruction Cache & Data Cache */ 
#define Flush_ID_Cache()						\
        do {								\
									\
	volatile dword_t* x;						\
        for (x = (dword_t*) 0xFFFFC000;					\
	     x != (dword_t*) 0x00000000;				\
	     x += 4)							\
	    __asm__ __volatile__ ("/* clean DCACHE */" : : "r"(*x));	\
									\
        __asm__ __volatile__						\
        (								\
        "mcr     p15, 0, r0, c7, c7, 0	\n"				\
        "mcr     p15, 0, r0, c7, c10, 4	\n"				\
         : : : "r0" );							\
        } while (0)

#endif /* !__ARM__EP7211__CPU_H__ */


