/*********************************************************************
 *                
 * Copyright (C) 2001,  Karlsruhe University
 *                
 * File path:     arm/space.h
 * Description:   Address space definition for the ARM
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * space.h,v 1.1 2001/12/07 19:05:12 skoglund Exp
 *                
 ********************************************************************/
#ifndef __ARM__SPACE_H__
#define __ARM__SPACE_H__

class space_t
{
    // Normal page directory.
    dword_t pgdir[1024];

public:
    inline dword_t * pagedir_phys (void)
	{ return (dword_t *) this; }

    inline dword_t * pagedir (void)
	{ return (dword_t *) phys_to_virt (this); }

    inline pgent_t * pgent (int n)
	{ return (pgent_t *) phys_to_virt (&pgdir[n]); }
};


INLINE space_t * get_current_space (void)
{
    return (space_t *) get_ttb ();
}

INLINE space_t * get_kernel_space (void)
{
    extern ptr_t kernel_ptdir;
    return (space_t *) virt_to_phys (kernel_ptdir);
}


#endif /* !__ARM_SPACE_H__ */

