/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *                
 * File path:     init.h
 * Description:   Declarations of initialization functions.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * init.h,v 1.16 2001/11/22 14:56:35 skoglund Exp
 *                
 ********************************************************************/
#ifndef __INIT_H__
#define __INIT_H__


/* From kmemory.c */
void kmem_init(void) L4_SECT_INIT;

/* From mapping.c */
void mdb_init(void) L4_SECT_INIT;
void mdb_buflist_init(void) L4_SECT_INIT;

/* From interrupts.c */
void interrupts_init() L4_SECT_INIT;

/* architecture specific initialization */
void init_arch_1() L4_SECT_INIT;
void init_arch_2() L4_SECT_INIT;
void init_arch_3() L4_SECT_INIT;

void setup_excp_vector() L4_SECT_INIT;

tcb_t * create_idle_thread() L4_SECT_INIT;


/* starts sigma 0 */
void create_sigma0();

/* starts root task */
void create_root_task();

void create_nil_tcb(void);

/* creates the thread that communicates with sigma0 */
void create_kmemthread();




/* the banner that gets printed through KDB on startup */
extern const char * kernel_version;


#endif /* __INIT_H__ */
