/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *                
 * File path:     interrupt.h
 * Description:   Interrupt handling declarations.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * interrupt.h,v 1.6 2001/11/22 14:56:35 skoglund Exp
 *                
 ********************************************************************/
#ifndef __INTERRUPT_H__
#define __INTERRUPT_H__

/* interrupt owner */
#define MAX_INTERRUPTS		32

/* defined in interrupt.c */
extern tcb_t * interrupt_owner[MAX_INTERRUPTS];

/* handlers called from architecture specific part */
void handle_timer_interrupt();
void handle_interrupt(dword_t number);

/* architecture specific interrupt masking */
void mask_interrupt(unsigned int number);
void unmask_interrupt(unsigned int number);

#endif /* __INTERRUPT_H__ */
