/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *                
 * File path:     macros.h
 * Description:   Collection of various "global" kernel macros.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * macros.h,v 1.8.2.1 2001/12/11 12:16:51 skoglund Exp
 *                
 ********************************************************************/
#ifndef __MACROS_H__
#define __MACROS_H__

/*
 * macros for CPP
 *
 * Precondition: __ARCH__ and __PLATFORM__ are defined
 * 
 * Use: If __ARCH__=x86 and __PLATFORM__=i686
 *    #include INC_ARCH(thread.h) includes include/x86/thread.h
 *    #include INC_PLATFORM(kdebug.h) includes include/x86/i686/thread.h
 *
 */
#define INC_ARCH(x) <__ARCH__/x>
#define INC_PLATFORM(x) <__ARCH__/__PLATFORM__/x>

#define L4_SECT_INIT		__attribute__ ((section (".init")))
#define L4_SECT_ROINIT		__attribute__ ((section (".roinit")))
#define L4_SECT_TEXT		__attribute__ ((section (".text")))
#define L4_SECT_KDEBUG		__attribute__ ((section (".kdebug")))
# define L4_SECT_CPULOCAL	

#define INLINE			static inline

#if (__GNUC__ >= 3)
#define EXPECT_TRUE(x)		__builtin_expect((x), 1)
#define EXPECT_FALSE(x)		__builtin_expect((x), 0)
#define EXPECT_VALUE(x,val)	__builtin_expect((x), (val))
#else /* __GNUC__ < 3 */
#define EXPECT_TRUE(x)		(x)
#define EXPECT_FALSE(x)		(x)
#define EXPECT_VALUE(x,val)	(x)
#endif /* __GNUC__ < 3 */


#endif /* __MACROS_H__ */
