/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *                
 * File path:     universe.h
 * Description:   File including all include files.  Using this scheme
 *                we only need to include a single file.  If we touch
 *                a single include file, however, we need to recompile
 *                the whole kernel, but since the kernel is small (in
 *                contrast to, e.g., Linux) we can live with that.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * universe.h,v 1.17.2.2 2001/12/11 12:16:51 skoglund Exp
 *                
 ********************************************************************/
#ifndef __UNIVERSE_H__
#define __UNIVERSE_H__

/* the file created by the xconfig tool */
#include <config.h>

#include <macros.h>
#include <types.h>

// kip and kernel identification
#include <kernel.h>

/* some of the include files rely on 
 * architecture specific configuration */
#include INC_ARCH(config.h)

#include <lib.h>

/* some of the macros of the notify mechanism are used to
   create function prototypes */
#include INC_ARCH(notify.h)

#include <kmemory.h>
#include <thread.h>
#include <ipc.h>
#include <tcb.h>
#include <schedule.h>
#include <interrupt.h>

#include INC_ARCH(cpu.h)
#include INC_ARCH(memory.h)
#include INC_ARCH(thread.h)




#include <kdebug.h>

#if defined(CONFIG_DEBUG)
# define ASSERT(x) do { if (!(x)) {printf("ASSERT(%s) failed in %s, file: %s:%d\n", #x, __FUNCTION__, __FILE__, __LINE__); enter_kdebug("ASSERT FAILED"); while(1);} } while (0)
#else
# define ASSERT(x) do { } while (0)
#endif
#endif /* __UNIVERSE_H__ */
