/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *                
 * File path:     x86/kdebug.h
 * Description:   x86 specific kdebug stuff.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * kdebug.h,v 1.18.2.1 2001/12/11 12:15:29 skoglund Exp
 *                
 ********************************************************************/
#ifndef __X86_KDEBUG_H__
#define __X86_KDEBUG_H__

#if defined(CONFIG_X86_P4_BTS) || defined(CONFIG_X86_P4_PEBS)
void init_tracestore(void) L4_SECT_INIT;
#endif


INLINE void spin(int pos = 80) {
    while(1) 
        ((word_t*)(KERNEL_VIDEO))[pos] += 1;
}

INLINE void spin1(int pos) {
#if defined(CONFIG_DEBUG_SPIN)
    ((char*)(KERNEL_VIDEO))[pos * 2] += 1;
    ((char*)(KERNEL_VIDEO))[pos * 2 + 1] = 7;
#endif
}

#define enter_kdebug(arg...)			\
__asm__ __volatile__ (				\
    "int $3;"					\
    "jmp 1f;"					\
    ".ascii	\"KD# " arg "\";"		\
    "1:")

INLINE ptr_t get_current_pgtable()
{
    ptr_t t;
    __asm__ __volatile__ ("mov	%%cr3, %0" : "=r" (t));
    return t;
}

#endif /* __X86_KDEBUG_H__ */
