/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *                
 * File path:     x86.lds
 * Description:   Generic linkser script for x86.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * x86.lds,v 1.18 2001/11/22 15:51:36 skoglund Exp
 *                
 ********************************************************************/
ENTRY(_start)

/* see also include/x86/config.h */
KERNEL_OFFSET = 0xF0000000;

text_paddr	= 0x00100000 + SIZEOF_HEADERS;
text_vaddr 	= text_paddr + KERNEL_OFFSET;

SECTIONS
{
	.text text_vaddr : AT (ADDR(.text) - KERNEL_OFFSET)
	{
		*(.mb_header)
		*(.ipc-s)
		*(.ipc-c)
		*(.text)
		*(.spinlock)

		/* The user-level accessible sysexit trampoline code */
		. = ALIGN(4K); _start_utramp = .;
		*(.utramp)
		. = ALIGN(4K); _end_utramp = .;
	}
	.data . : AT (ADDR(.data) - KERNEL_OFFSET)
	{
		*(.data)
	}
	.kdebug . : AT (ADDR(.kdebug) - KERNEL_OFFSET)
	{
		*(.rodata .kdebug)
	}

	.bss . : AT (ADDR(.bss) - KERNEL_OFFSET)
	{
		*(.bss)
	}

	/* the .cpulocal section is a per CPU .bss -> NOLOAD */
	.cpulocal ALIGN(4K) (NOLOAD): AT (ADDR(.cpulocal) - KERNEL_OFFSET)
	{
		_start_cpu_local = .;
		*(.cpulocal)
		*(.kdebug-bss)
		_end_cpu_local = ALIGN(4K);
	}

	_end_text = ALIGN(4K);
	_end_text_p = (_end_text - KERNEL_OFFSET);
	_start_utramp_p = (_start_utramp - KERNEL_OFFSET);

	.init _end_text_p :
	{
		*(.init .roinit)
	}

	/* throw away all other sections */

	/*
	This one also throws away debugging info
	/DISCARD/ : { *(*) }
	*/

	/DISCARD/ : {
		*(.eh_frame)
		*(.note)
		*(.comment)
	}
}
