/*********************************************************************
 *                
 * Copyright (C) 1999, 2000, 2001,  Karlsruhe University
 *                
 * File path:     arm/brutus/startup.S
 * Description:   Startup code for the Brutus.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * startup.S,v 1.10 2001/12/13 12:23:36 ud3 Exp
 *                
 ********************************************************************/
#include <macros.h>
#include INC_PLATFORM(platform.h)
#include INC_ARCH(cpu.h)

	.globl	_start
	.section .init,"xa"
_start:
	/* Switch to abort mode */
	mov	r0, #(IRQ_MASK|FIQ_MASK|KERNEL_MODE)
	msr	cpsr, r0

	/* reset spsr */
	mov	r0, #0xd3
	msr	spsr, r0

	/* Initialize stack pointer */
	ldr	sp, 5f

	/* Build the initial page table */
	bl	setup_kernel_pgtable__Fv

	/* Enable the MMU */
	ldr	r0, 1f
	mcr     p15, 0, r0, c2, c0	@ Set Translation Table Base
	mov	r0, #0x00000005
	mcr	p15, 0, r0, c3, c0	@ Access checking for Domain 1
	ldr	r0, 2f
	mcr	p15, 0, r0, c1, c0	@ Enable the MMU
	nop
	nop
	nop

	/* Call init() */
        ldr     pc, 4f

1:	.word	kernel_ptdir_p
#ifdef EXCEPTION_VECTOR_RELOCATED
2:	.word	(CTL_MMU_ENABLED | CTL_ICACHE | CTL_DCACHE | CTL_WRITE_BUF | CTL_SYS_PROT | CTL_IVECTOR)
#else
2:	.word	(CTL_MMU_ENABLED | CTL_SYS_PROT)
#endif
3:	.word	kernel_ptdir
4:      .word   init__Fv
5:	.word	_stack_top

	/* Initializtation stack */
_stack_bottom:
	.space 4096
_stack_top:
