/*********************************************************************
 *                
 * Copyright (C) 2000, 2001,  Karlsruhe University
 *                
 * File path:     arm/mapping.c
 * Description:   Mapping specifications for the ARM.
 *                
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *                
 * mapping.c,v 1.3 2001/11/22 13:18:48 skoglund Exp
 *                
 ********************************************************************/
#include <universe.h>
#include <mapping.h>

dword_t mdb_pgshifts[5] = {
    10,		// 1KB
    12,		// 4KB
    16,		// 64KB
    20,		// 1MB
    32		// 4GB (whole address space)
};

mdb_buflist_t mdb_buflists[6] = {
    { 12 },	// Mapping nodes
    { 8 },	// ptrnode_t
    { 64 },	// 64KB array, 4KB array
    { 16 },	// 1KB array
    { 16384 },	// 1MB array
    { 0 }
};

